%CODCHROMA Compute a transform-domain chromagram based on 8xMDCT codec
%   C=CODCHROMA(FILENAME,BITRATE) decodes the given 8xMDCT coded file 
%   FILENAME with the bitrate (BITRATE) in bits per second and returns the 
%   transform-domain chromagram C.
%
%   C=CODCHROMA(FILENAME,BITRATE,P) sets the paramaters (P is a structure):
%   - P.minBlock: min block index of the selected atoms. (Default: 7, it
%   means that only atoms from the 7th (window size 8192) and 8th
%   (window size 16384) blocks are selected).
%   - P.hopsize: chromagram hop size (Default: 8192).
%   - P.bpo: bin per octave (Default: 36).
%   - P.fmin: minimum frequency in Hz (Default: 73.4162).
%   - P.fmax: maximum frequency in Hz (Default: fmin*16).

%   Mex implementation in codchroma.cpp
