/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __BITPLANE_H
#define __BITPLANE_H

class bitplane {

public:
	bitstream *bs;
	double *data_dec;
	unsigned char *sig;
	long unsigned int level;
	unsigned int data_len;
	double data_max;
	double data_max_q;
	unsigned int data_max_q_u;
	long unsigned int level_max;
	unsigned int bp_len;

public:
	bitplane( unsigned int set_data_len );
	~bitplane( void );
	void decode( bitstream *bs, double *bufferOut, double greatest_amp, int data_max_nbits, int k_init );
	int bitplane_decode( bitstream *bs, int k_init );
	void new_coef( unsigned int n, unsigned int sign );
	void refine_coef( unsigned int n, unsigned int ref_bit );
};

#endif
