/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __DECODER_H
#define __DECODER_H

#include <stdio.h>
#include "bitstream.h"
#include "bitplane.h"
#include "interleave.h"

class decoder {

public:

	FILE *fid;
	unsigned int numSamples;
	unsigned int sampleRate;
	unsigned int firstNonZeroSlot;
	unsigned int lastNonZeroSlot;
	unsigned int numSlots;
	unsigned int numBlocks;
	unsigned int slot;
	bool is_psy;
	bitstream *bs;
	bitplane *bp;
	interleave *ci;
	double *buffer;


public:
	decoder( FILE *set_fid );
	~decoder( void );
	int decode_slot( double bitrate );	
	int get_numFrames( int block );
	int get_numFreqs( int block );
	double get_coef( int block, int frame, int freq );
};

#endif
