clear all
close all

N = 8;
M = 40;
filename = 'dct.h';

DCT = cell(N,M);
for v=1:N
    for u=1:M
        DCT{v,u} = zeros(N,M);
        for y=1:N
            for x=1:M
                DCT{v,u}(y,x) = sqrt(2/N)*sqrt(2/M)*cos((pi*(v-1)/(2*N))*(2*(y-1)+1))*cos((pi*(u-1)/(2*M))*(2*(x-1)+1));
                if v==1
                    DCT{v,u}(y,x) = DCT{v,u}(y,x)*sqrt(1/2);
                end
                if u==1
                    DCT{v,u}(y,x) = DCT{v,u}(y,x)*sqrt(1/2);
                end
            end
        end
    end
end

fid=fopen(filename,'w');
fprintf(fid,'const double dct[%d][%d][%d][%d]={',N,M,N,M);
for v=1:N
    fprintf(fid,'{');
    for u=1:M
        fprintf(fid,'{');
        for y=1:N
            fprintf(fid,'{');
            for x=1:M
                fprintf(fid,'%.20f',DCT{v,u}(y,x));
                if x<M
                    fprintf(fid,',');
                end
            end
            fprintf(fid,'}');
            if y<N
                fprintf(fid,',');
            end
        end
        fprintf(fid,'}');
        if u<M
            fprintf(fid,',');
        end
    end
    fprintf(fid,'}');
    if v<N
        fprintf(fid,',');
    end
end
fprintf(fid,'};\n\n');
fclose(fid);
